$ gosub start_init
$ goto handle_args

$ shift_args:
$ p1 = p2
$ p2 = p3
$ p3 = p4
$ p4 = p5
$ p5 = p6
$ p6 = p7
$ p7 = p8
$ p8 = ""
$ return

$start_init:
$ define_gcc = 0
$ ws = "write sys$output"
$ cc = "cc"
$! cc = "cc/nodebug"
$ link = "link"
$! link = "link/notrace"
$! link = "link/map/full/cross/notrace"
$ link_lib = "sys$library:vaxcrtl/share"
$ WR = "write sys$output"
$!!
$!! Find the current disk and directory !!
$ dev_temp = f$trnlnm("sys$disk")
$ dir_temp = f$directory()
$!!
$!! Short setup for the test program !!
$ test_args = ""
$ test = "$ ''dev_temp'''dir_temp'test.exe"
$!!
$!! !!
$ ON CONTROL_Y then goto exit_program
$ ON ERROR then goto exit_program
$ return

$install_procedure:
$ gosub read_defaults
$ if READ_DEFAULTS.EQS."FALSE"
$ then
$   write sys$output "You should compile first."
$   exit
$ endif
$ create/dir/prot=(s:rwed,o:rwe,g:re,w:re) 'install_dir
$ copy irc.exe 'install_dir
$ create/dir/prot=(s:rwed,o:rwe,g:re,w:re) 'install_script
$ if f$search("'install_dir'ircii.servers").eqs.""
$ then
$   copy ircii.servers 'install_dir'ircii.servers
$ endif
$ copy global.ircrc 'install_dir
$ copy irchelp.hlb 'install_dir
$ delete/noconfirm global.ircrc;
$!
$ copy *.irc 'install_script
$ delete/noconfirm *.irc;
$ set prot=(s:rwed,o:rwed,g:e,w:e) 'install_dir'irc.exe
$ set prot=(s:rwed,o:rwed,g:r,w:r) 'install_dir'ircii.servers
$ set prot=(s:rwed,o:rwed,g:r,w:r) 'install_dir'irchelp.hlb
$ set prot=(s:rwed,o:rwed,g:r,w:r) 'install_dir'global.ircrc
$ set prot=(s:rwed,o:rwed,g:r,w:r) 'install_script'*.irc;
$ exit

$handle_args:
$!
$ if p1.eqs."CROSS"
$ then
$  define_gcc = 1
$  inquire/nopunc/local test_args  "Remote machine? "
$  inquire/nopunc/local network_software  "Software type? "
$  define network_software 'network_software
$  link_lib = "sys$library:vaxcrtl/lib"
$  gosub shift_args
$ endif
$!
$! Uncomment the next line if you use gcc
$ if define_gcc.eq.1 then cc = "gcc"
$! for GCC, add "GNU_CC:[000000]GCCLIB/LIB" to the BEGINNING of o.opt
$!
$ if p1.eqs."CLEAN" then goto cleanup
$ if p1.eqs."INSTALL" then goto install_procedure
$ gosub make_symbols
$ on warning then continue
$!
$ isvax = "TRUE"
$ set noon
$ if f$getsyi("arch_name").nes."VAX" then isvax = "FALSE"
$ set on
$ if define_gcc.eq.1
$ then
$   open/write o_opt o.opt
$   write o_opt "GNU_CC:[000000]GCCLIB/LIB"
$   write o_opt ''link_lib'
$   close o_opt
$!SYS$LIBRARY:VAXCRTL/SHARE
$ else
$   if isvax.eqs."FALSE"
$   then
$     open/write o_opt o.opt
$     close o_opt
$!    CC="CC/PREFIX_LIBRARY_ENTRIES=ALL_ENTRIES/WARN=(ENABLE=CHECK)"
$     CC="''CC'/PREFIX_LIBRARY_ENTRIES=ALL_ENTRIES"
$   else
$     open/write o_opt o.opt
$     write o_opt ''link_lib'
$     close o_opt
$   endif
$ endif
$ on warning then continue
$ define/nolog sys$input sys$command
$ message = f$environment("MESSAGE")
$ set mess/nofaci/nosev/noid/notext
$ if f$trnlnm("network_software").nes.""
$ then
$   wr "User setting networking software type."
$   argh="''f$trnlnm("network_software")"
$ else
$   argh="UCX"
$   if f$getdvi("INET0", "DEVNAM").nes."" then argh="MULTINET"
$ endif
$ WR "Setting you up for a ''argh' system."
$ set message'message'
$ gosub init_files
$ if p1.eqs."PCA"
$ then
$   if define_gcc.eq.1
$   then
$     cc = "''cc'/debug/noopt/profile"
$   else
$     cc = "''cc'/DEBUG"
$     link = "''link'/DEBUG=SYS$LIBRARY:PCA$OBJ.OBJ"
$   endif
$   gosub shift_args
$ endif
$ if p1.eqs."DEBUG"
$ then
$   cc = "''cc'/DEBUG=ALL/NOOPT"
$   link = "''link'/DEBUG"
$   gosub shift_args
$ endif
$ if p1.eqs."LINK" then goto link
$ if p1.eqs."ALL"
$ then
$   loop = 1
$label1:
$   if file'loop'.eqs.p2 then goto all_loop
$   loop = loop + 1
$   if loop.gt.'num_files' then goto all
$   goto label1
$ else
$   if p1.eqs.""
$   then
$     goto all
$   else
$     loop = 1
$label:
$     if file'loop'.eqs.p1 then gosub compileit
$     loop = loop + 1
$     if loop.gt.'num_files' then exit
$     goto label
$   endif
$ endif
$ exit

$all:
$ loop=1
$all_loop:
$ gosub compileit
$ loop = loop + 1
$ if loop.gt.'num_files' then goto link
$ goto all_loop

$compileit:
$ dummy = file'loop'
$ my_label = "file"'loop'"_c"
$ if f$type('my_label').eqs.""
$ then
$   ws dummy
$   'cc/define=('argh') 'dummy'.c
$ else
$  gosub &'my_label'
$!   gosub file'loop'_c
$ endif
$ return

$ READ_DEFAULTS:
$	READ_DEFAULTS = "FALSE"
$	OPEN /READ/ERROR=END_READ_DEF_OPEN saved_file saved.options
$	READ /ERROR=END_READ_DEF saved_file install_dir
$	READ /ERROR=END_READ_DEF saved_file install_script
$	READ /ERROR=END_READ_DEF saved_file install_server
$	READ /ERROR=END_READ_DEF/END=NEXT saved_file install_port
$ NEXT:
$	READ_DEFAULTS = "TRUE"
$ END_READ_DEF:
$	close saved_file
$ END_READ_DEF_OPEN:
$ RETURN

$ make_symbols:
$	if f$type(install_dir).nes."" then goto make_new_symbols
$	gosub read_defaults
$	if READ_DEFAULTS.EQS."TRUE"
$	then
$		gosub print_variables
$		return
$	endif
$ make_new_symbols:
$	read_done = 0
$	WR = "write sys$output"
$	if f$type(install_dir).eqs."" then install_dir = f$environment("default")
$	len = f$length(install_dir)
$	loc = f$locate("]", install_dir)
$	install_script = "''f$extract(0, loc, install_dir)'.SCRIPTS]"
$	if f$type(install_port).eqs."" then install_port = 6667
$	if f$type(install_server).eqs."" then install_server = "irc.colorado.edu"
$ not_done:
$	gosub print_variables
$	gosub reset_variables
$	if read_done.eq.0 then goto not_done
$	open/write saved_file saved.options
$	write saved_file install_dir
$	write saved_file install_script
$	write saved_file install_server
$	write saved_file install_port
$	close saved_file
$ return

$ get_input:
$	read/prompt="''prompt'" SYS$COMMAND dummy
$ return

$ reset_variables:
$	prompt = "Which would you like to change? "
$	gosub get_input
$	saved_dummy = "''dummy'"
$	if (saved_dummy.ne.5).and.(saved_dummy.ne."")
$	then
$		prompt = "New value? "
$		gosub get_input
$	endif
$	if saved_dummy.eqs."" then read_done = 1
$	if saved_dummy.eqs."1" then install_dir = "''dummy'"
$	if saved_dummy.eqs."2" then install_script = "''dummy'"
$	if saved_dummy.eqs."3" then install_server = "''dummy'"
$	if saved_dummy.eqs."4" then install_port = "''dummy'"
$	if saved_dummy.eqs."5" then read_done = 1
$ return

$ print_variables:
$	WR = "write sys$output"
$	WR "------------------------------------------"
$	WR "1) Install path: ''install_dir'"
$	WR "2) Script directory: ''install_script'"
$	WR "3) Default server: ''install_server'"
$	WR "4) Default port: ''install_port'"
$	WR "5) Continue with the installation."
$	WR "------------------------------------------"
$ return
$!

$qio_block:
$   ws dummy
$   'cc/define=('argh') 'dummy'.c
$ return

$test_block:
$   ws dummy
$   'cc/define=('argh') 'dummy'.c
$   gosub link2
$ return

$set_block:
$   ws dummy
$   test 'test_args
$   'cc/define=(LOAD_PATH_EXT="""''install_script'""",'argh',-
HELP_PATH="""''install_dir'""",-
DEFAULT_NAMESERVER="""''name_server'""") 'dummy'.c
$ return

$sock_block:
$   ws dummy
$   'cc/define=(DEF_SERVER="""''install_server'""",DEF_PORT='install_port','argh') 'dummy'.c
$ return

$init_files:
$ file1   = "NSLOOKUP"
$ file2   = "QIO"
$ file2_c = "qio_block"
$ file3   = "QIO_VAR"
$ file4   = "TEST"
$ file4_c = "test_block"
$ file5   = "ALIAS"
$ file6   = "BINDING"
$ file7   = "CHAN"
$ file8   = "COMMAND"
$ file9  = "DCC"
$ file10  = "GLOBAL"
$ file11  = "HANDLE"
$ file12  = "IGNORE"
$ file13  = "INP"
$ file14  = "IRCHELP"
$ file15  = "LEVEL"
$ file16  = "LIST"
$ file17  = "LOAD"
$ file18  = "MYCOMPARE"
$ file19  = "NOTIFY"
$ file20  = "ON"
$ file21  = "SET"
$ file21_c= "SET_BLOCK"
$ file22  = "SOCK"
$ file22_c= "sock_block"
$ file23  = "SPLIT"
$ file24  = "STARTUP"
$ file25  = "SYSTEM"
$ file26  = "WINDOW"
$ file27  = "WINFUNC"
$ file28  = "FF"
$ file29  = "EXEC"
$ file30  = "BUILTIN"
$ file31  = "QUEUE"
$ num_files = 31
$ return

$link2:
$ link test.obj,nslookup.obj,qio.obj,qio_var.obj,o/opt
$ return

$link:
$ ws "master link"
$   'link'/exe=irc 'file1'.obj, 'file2'.obj,  'file3'.obj,  'file5'.obj, -
    'file6'.obj,  'file7'.obj,  'file8'.obj,  'file9'.obj,  'file10'.obj, -
    'file11'.obj, 'file12'.obj, 'file13'.obj, 'file14'.obj, 'file15'.obj, -
    'file16'.obj, 'file17'.obj, 'file18'.obj, 'file19'.obj, 'file20'.obj, -
    'file21'.obj, 'file22'.obj, 'file23'.obj, 'file24'.obj, 'file25'.obj, -
    'file27'.obj, 'file26'.obj, 'file28'.obj, 'file29'.obj, 'file30'.obj, -
    'file31'.obj, o/opt
$ ws "Linking complete."
$!
$! Take care of the default server list.
$ if f$search("ircii.servers").eqs.""
$ then
$   open/write server_file ircii.servers
$   write server_file "''install_server' ''install_port'"
$   close server_file
$ endif
$! Originally had it create it right in the proper directory.
$! what happens if the directory doesn't exist?
$ library/create/help irchelp.hlb irchelp.hlp
$ EXIT

$ opening_file:
$	write sys$output "Could not open the file -fatal-"
$	goto exit_program
$ exit

$ exit_program:
$	message = f$environment("MESSAGE")
$	set mess/nofaci/nosev/noid/notext
$	close saved_file
$	set message'message'
$ exit

$ cleanup:
$	purge/nocon
$	delete *.obj;*/nocon
$	delete saved.options;*/nocon
$	delete *.exe;*/nocon
$ exit
